'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var postcss = _interopDefault(require('postcss'));

var selectorRegExp = /:focus-visible([^\w-]|$)/gi;

var index = postcss.plugin('postcss-focus-visible', function (opts) {
	var replaceWith = String(Object(opts).replaceWith || '.focus-visible');
	var preserve = Boolean('preserve' in Object(opts) ? opts.preserve : true);

	return function (root) {
		root.walkRules(selectorRegExp, function (rule) {
			var selector = rule.selector.replace(selectorRegExp, function ($0, $1) {
				return `${replaceWith}${$1}`;
			});

			var clone = rule.clone({ selector });

			if (preserve) {
				rule.before(clone);
			} else {
				rule.replaceWith(clone);
			}
		});
	};
});

module.exports = index;
